<script setup lang="ts">
import { ref, computed, watch } from "vue";
import { useQuasar } from "quasar";

import { useCounterMixin } from "@/stores/mixin";
import { useRetirementDataStore } from "@/modules/06_retirement/store/Main";
import { useRoleWorkflowDataStore } from "@/stores/roleWorkflow";

import type { PropType } from "vue";
import type { QTableProps } from "quasar";
import type { ResponseItems } from "@/modules/06_retirement/interface/response/Main";

import DialogHeader from "@/components/DialogHeader.vue";
import DialogCreateCommand from "@/modules/18_command/components/DialogCreateCommand.vue";

/** use */
const $q = useQuasar();
const stroe = useRetirementDataStore();
const { fetchDataCheckIsoffice } = useRoleWorkflowDataStore();
const { statusText } = stroe;
const selected = ref<ResponseItems[]>([]);
const dataMapToSend = computed(() => {
  return selected.value.map((i: any) => ({
    id: i.id,
    profileId: i.profileId,
    prefix: i.prefix,
    firstName: i.firstName,
    lastName: i.lastName,
    citizenId: i.citizenId,
    remarkVertical: i.reasonResign,
    remarkHorizontal: i.remarkHorizontal,
    position: i.positionOld,
    posType: i.positionTypeOld,
    posLevel: i.positionLevelOld,
  }));
});
const mixin = useCounterMixin();
const { dialogConfirm, date2Thai, onSearchDataTable, messageError } = mixin;

/** props*/
const props = defineProps({
  modal: { type: Boolean, requreid: true },
  closeModal: { type: Function, requreid: true },
  fecthList: { type: Function, requreid: true },
  rows: { type: Array as PropType<ResponseItems[]>, requreid: true },
  mainTabs: { type: String, requreid: true },
  cancel: { type: Boolean, default: false },
});

//Table
const filterKeyword = defineModel<string>("filterKeyword", { required: true });
const rowsData = ref<ResponseItems[]>([]);
const rowsDataMain = ref<ResponseItems[]>([]);
const columns = ref<QTableProps["columns"]>([
  {
    name: "no",
    align: "left",
    label: "ลำดับ",
    sortable: false,
    field: (row) => rowsData.value!.indexOf(row) + 1,
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "fullname",
    align: "left",
    label: "ชื่อ-นามสกุล",
    sortable: true,
    field: "fullname",
    format(val, row) {
      return `${row.prefix}${row.firstName} ${row.lastName}`;
    },
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "location",
    align: "left",
    label: "สถานที่ยื่นขอลาออกจากราชการ",
    sortable: true,
    field: "location",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "positionLevel",
    align: "left",
    label: "ตำแหน่งประเภท",
    sortable: true,
    field: "positionLevel",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      let name = "";
      if (row.positionTypeOld && row.positionLevelOld) {
        name = `${row.positionTypeOld} (${row.positionLevelOld})`;
      } else if (row.positionTypeOld) {
        name = `${row.positionTypeOld}`;
      } else if (row.positionLevelOld) {
        name = `(${row.positionLevelOld})`;
      } else name = "-";
      return name;
    },
  },
  {
    name: "positionNumberOld",
    align: "left",
    label: "เลขที่ตำแหน่ง",
    sortable: true,
    field: "positionNumberOld",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "organizationPositionOld",
    align: "left",
    label: "ตำแหน่ง/สังกัดเดิม",
    sortable: true,
    field: "organizationPositionOld",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",

    // กรณี copy ทั้งหมด เเล้ว ค้นหา
    // format(val, row) {
    //   return `${row.organizationPositionOld.replace(/\n/g, " ")}`;
    // },
  },
  {
    name: "datetext",
    align: "left",
    label: "วันที่ยื่น",
    sortable: true,
    field: "createdAt",
    format(val, row) {
      return date2Thai(new Date(val));
    },
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sortOrder: "da",
  },
  {
    name: "status",
    align: "left",
    label: "สถานะ",
    sortable: true,
    field: "status",
    format(val, row) {
      return props.mainTabs === "1"
        ? statusText(row.status)
        : statusText(row.status, "อนุญาต");
    },

    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
]);
const visibleColumns = ref<string[]>([
  "no",
  "prefix",
  "fullname",
  "location",
  "positionLevel",
  "positionNumberOld",
  "organizationPositionOld",
  "datetext",
  "status",
]);

const modalCommand = ref<boolean>(false);

/** popup ยืนยันส่งัว */
function saveOrder() {
  // dialogConfirm(
  //   $q,
  //   () => {
  props.closeModal?.();
  modalCommand.value = true;
  //   },
  //   "ยืนยันส่งไปออกคำสั่ง",
  //   "ต้องการยืนยันส่งไปออกคำสั่งใช่หรือไม่?"
  // );
}

const emit = defineEmits(["update:filterKeyword2", "update:selected"]);
function updateInput(value: any) {
  emit("update:filterKeyword2", value);
}

async function onSearch() {
  rowsData.value = onSearchDataTable(
    filterKeyword.value,
    rowsDataMain.value,
    columns.value ? columns.value : []
  );
}

const isOfficer = ref<boolean>(false);
const isStaff = ref<boolean>(false);

/** ฟังก์ดึงข้อมูลผู้บังคับบัญชา*/
async function fetchCheckOfficer() {
  try {
    const data = await fetchDataCheckIsoffice("SYS_RESIGN");
    isOfficer.value = data.isOfficer;
    isStaff.value = data.isStaff;
  } catch (err) {
    messageError($q, err);
  }
}

watch(
  () => props.modal,
  async (val) => {
    if (val) {
      selected.value = [];
      await fetchCheckOfficer();
      const data = props?.rows?.filter((e: any) => {
        if (
          isStaff.value ||
          (e.organizationPositionOld?.includes("สำนักปลัดกรุงเทพมหานคร") &&
            isOfficer.value &&
            e.group === "1.1")
        ) {
          return e.group === "1.1";
        } else {
          return e.group !== "1.1";
        }
      });

      rowsData.value = data ? data : [];
      rowsDataMain.value = data ? data : [];
    } else {
      rowsData.value = [];
      rowsDataMain.value = [];
    }
  }
);
</script>
<template>
  <q-dialog v-model="props.modal" persistent>
    <q-card style="min-width: 85%">
      <DialogHeader
        :tittle="`ส่งไปออกคำสั่ง${cancel ? 'ยกเลิกการ' : ''}ลาออก`"
        :close="closeModal"
      />
      <q-separator />
      <q-card-section>
        <div class="row col-12 q-col-gutter-sm">
          <div class="col-12 row">
            <q-space />
            <q-input
              borderless
              outlined
              dense
              v-model="filterKeyword"
              @keydown.enter.prevent="onSearch"
              placeholder="ค้นหา"
            >
              <template v-slot:append>
                <q-icon name="search" />
              </template>
            </q-input>
            <q-select
              v-model="visibleColumns"
              multiple
              outlined
              dense
              options-dense
              :display-value="$q.lang.table.columns"
              emit-value
              map-options
              :options="columns"
              option-value="name"
              style="min-width: 140px"
              class="gt-xs q-ml-sm"
            />
          </div>

          <div class="col-12">
            <d-table
              :columns="columns"
              :rows="rowsData"
              row-key="id"
              :visible-columns="visibleColumns"
              selection="multiple"
              v-model:selected="selected"
            >
              <template v-slot:header-selection="scope">
                <q-checkbox
                  keep-color
                  color="primary"
                  dense
                  v-model="scope.selected"
                />
              </template>

              <template v-slot:body="props">
                <q-tr :props="props" class="cursor-pointer">
                  <q-td>
                    <q-checkbox
                      keep-color
                      color="primary"
                      dense
                      v-model="props.selected"
                    />
                  </q-td>
                  <q-td v-for="col in props.cols" :key="col.id">
                    <div
                      v-if="col.name == 'organizationPositionOld'"
                      class="text-html"
                    >
                      {{
                        props.row.organizationPositionOld
                          ? props.row.organizationPositionOld
                          : "-"
                      }}
                    </div>
                    <div v-else>
                      {{ col.value ? col.value : "-" }}
                    </div>
                  </q-td>
                </q-tr>
              </template>
            </d-table>
          </div>
        </div>
      </q-card-section>

      <q-card-actions align="right" class="bg-white text-teal">
        <q-btn
          label="ส่งไปออกคำสั่ง"
          @click="saveOrder"
          :disable="selected.length === 0"
          color="public"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>

  <DialogCreateCommand
    v-model:modal="modalCommand"
    :command-type-code="props.mainTabs === '1' ? 'C-PM-17' : 'C-PM-41'"
    :persons="dataMapToSend"
    :fetch-data="props.fecthList"
  />
</template>
